////// $URL: http://svn.uv-software.com/opensource/linux/CANopen/COPbrowser/trunc/COPbrowser.h $
//
//	project   :  COPbrowser - CANopen Object Browser
//
//	purpose   :  COPbrowser - Resource file
//
//	copyright :  (C) 2009, UV Software, Friedrichshafen
//
//	compiler  :  GCC - GNU C++ Compiler (Linux Kernel 2.6)
//
//	export    :  (see below)
//
//	includes  :  (none)
//
//	author    :  Uwe Vogt, UV Software
//
//	e-mail    :  uwe.vogt@uv-software.de
//
//////////////////////////////////////////////////////////////////////////////
//	COPbrowser - Resource file
//
//	Defines resources like version information, registry keys and tool tips.

#ifndef _COPbrowser_h_
#define _COPbrowser_h_

//////////////////////////////////////////////////////////////////////////////
//	Version information

#define PROGRAM_STRING					"COPbrowser"
#define APPLICATION_STRING				"CANopen Object Browser"
#define COMPANY_STRING					"UV Software"
#define LOCATION_STRING					"Friedrichshafen"
#define COUNTRY_STRING					"Germany"
#define AUTHOR_STRING					"Uwe Vogt"
#define MAILTO_STRING					"uwe.vogt@uv-software.de"
#define INTERNET_STRING					"http://www.uv-software.de/"
#define COPYRIGHT_STRING				"(C) 2009, UV Software, Friedrichshafen"
#define LICENSE_STRING					"FREEWARE (without Warranty or Support)"
#define VERSION_NUMBER_STRING			"0.2"
#define REVISION_NUMBER_STRING			"$Rev: 63 $"

//////////////////////////////////////////////////////////////////////////////
//	Registry key

#define WINDOWS_REGISTRY				COMPANY_STRING
#define APPLICATION_KEY					APPLICATION_STRING
#define RECENT_FILES_KEY				"Recent File List"
#define RECENT_FILEi_KEY				"File"
#define INTERFACES_KEY					"Used Interfaces"
#define INTERFACEi_KEY					"Interface"
#define SETTINGS_KEY					"Settings"
#define DISPLAY_MODE_KEY				"Display"

//////////////////////////////////////////////////////////////////////////////
//	String resources

#define DOCUMENT_TYPE					"CANopen EDS-file"
#define DOCUMENT_EXT					"*.eds"
#define DOCUMENT_FILTER					"CANopen EDS-files (*.eds);;Any files (*)"
#define DOCUMENT_UNNAMED				"unnamed document"

//////////////////////////////////////////////////////////////////////////////
//	Image resources

#define PROGRAM_ICON					"program.png"
#define DOCUMENT_ICON					"document.png"
#define FILEOPEN_ICON					"fileopen.png"
#define FILEPRINT_ICON					"fileprint.png"
#define FILECLOSE_ICON					"fileclose.png"
#define EXIT_ICON						"exit.png"
#define DEVICEINFO_ICON					"deviceinfo.png"
#define CONTENTS_ICON					"contents.png"
#define CONTEXTHELP_ICON				"contexthelp.png"

//////////////////////////////////////////////////////////////////////////////
//	Tip resources

#define FILE_OPEN_STATUSTIP				"Open an object dictionary from an existing EDS-file and optionally connect it to a CANopen node"
#define FILE_OPEN_WHATsTHIS				"Use the <i>Open</i> command from the <i>File</i> menu or press <i>Ctrl+O</i> to open an object dictionary of a CANopen device from an <u>EDS-file</u>. " \
										"For data accesses the EDS-file can be connected to a CANopen node in the present CANopen network."
#define FILE_PRINT_STATUSTIP			"Print the active object dictionary"
#define FILE_PRINT_WHATsTHIS			"Use the <i>Print</i> command from the <i>File</i> menu or press <i>Ctrl+P</i> to print the active object dictionary."
#define FILE_CLOSE_STATUSTIP			"Close the active object dictionary"
#define FILE_CLOSE_WHATsTHIS			"Use the <i>Close</i> command from the <i>File</i> menu or press <i>Ctrl+W</i> to close the active object dictionary."
#define FILE_CLOSE_ALL_STATUSTIP		"Close all object dictionaries"
#define FILE_CLOSE_ALL_WHATsTHIS		"Use the <i>Close All</i> command from the <i>File</i> menu to close all object dictionaries"
#define FILE_EXIT_STATUSTIP				"Exit the application"
#define FILE_EXIT_WHATsTHIS				"Use the <i>Exit</i> command from the <i>File</i> menu or press <i>Ctrl+Q</i> to exit the application."
#define	DEVICE_INFO_STATUSTIP			"Show the DeviceInfo section from the active object dictionary"
#define	DEVICE_INFOT_WHATsTHIS			"Use the <i>Device Info</i> command from the <i>Device</i> menu to show the DeviceInfo section from the active object dictionary."
#define	INTERFACE_INITIALIZE_STATUSTIP	"Initialize the CAN interface"
#define	INTERFACE_INITIALIZE_WHATsTHIS	"Use the <i>Initialize</i> command from the <i>Interface</i> menu to initialize the CAN interface."
#define	INTERFACE_PROPERTIES_STATUSTIP	"Show properties of the CAN interface"
#define	INTERFACE_PROPERTIES_WHATsTHIS	"Use the <i>Properties</i> command from the <i>Interface</i> menu to show properties of the CAN interface."
#define WINDOWS_CASCADE_STATUSTIP		"Arrange all windows so they overlap"
#define WINDOWS_CASCADE_WHATsTHIS		"Use the <i>Cascade</i> command from the <i>Windows</i> menu to arrange all windows so they overlap"
#define WINDOWS_TILE_STATUSTIP			"Arrange all windows as non-overlapping tiles"
#define WINDOWS_TILE_WHATsTHIS			"Use the <i>Tile</i> command from the <i>Windows</i> menu to arrange all windows as non-overlapping tiles."
#define HELP_CONTENTS_STATUSTIP			"Open the online help file"
#define HELP_CONTENTS_WHATsTHIS			"Use the <i>Contents</i> command from the <i>Help</i> menu or press <i>F1</i> key to open the online help file."
#define HELP_CONTEXTHELP_STATUSTIP		"Show context-sensitive help"
#define HELP_CONTEXTHELP_WHATsTHIS		"Use the <i>What's This</i> command from the <i>Help</i> menu or press <i>Shift+F1</i> to show context-sensitive help for clicked on buttons, menus and windows."
#define HELP_ABOUT_STATUSTIP			"Show the application's About box"
#define HELP_ABOUT_WHATsTHIS			"Use the <i>About</i> command from the <i>Help</i> menu to show program information, version number and copyright."
#define HELP_ABOUT_QT_STATUSTIP			"Show the Qt library's About box"
#define HELP_ABOUT_QT_WHATsTHIS			"Use the <i>About Qt</i> command from the <i>Help</i> menu to show Qt library information, version number and copyright."
#define MDI_WINDOW_STATUSTIP			"Object Dictionary window"
#define MDI_WINDOW_WHATsTHIS			"The Object Dictionary window displays the CANopen object dictionary of a CANopen device taken either from an EDS-File or from a XML-File. On the left side of the window all objects are listed in a tree view order by categories. To navigate through the object tree use either the cursor-up/-down keys or click with the mouse on an item. On the right side all attributes and attribute values of the highlighted object are shown."
#define OBJECT_DICTIONARY_STATUSTIP		"Object Dictionary"
#define OBJECT_DICTIONARY_WHATsTHIS		"..."
#define OBJECT_DESCRIPTION_STATUSTIP	"Object attributes"
#define OBJECT_DESCRIPTION_WHATsTHIS	"..."
#define OBJECT_NAME_STATUSTIP			"Object name"
#define OBJECT_NAME_WHATsTHIS			"Name of the object."
#define OBJECT_CODE_STATUSTIP			"Object code"
#define OBJECT_CODE_WHATsTHIS			"Object code: VAR, ARRAY, RECORD, ...."
#define OBJECT_TYPE_STATUSTIP			"Data type"
#define OBJECT_TYPE_WHATsTHIS			"Data type of the object."
#define OBJECT_COMPOUND_STATUSTIP		"If it is an ARRAY or a RECORD"
#define OBJECT_COMPOUND_WHATsTHIS		"The check mark is set in case of an ARRAY or a RECORD."
#define OBJECT_MANDATORY_STATUSTIP		"If it is a mandatory object"
#define OBJECT_MANDATORY_WHATsTHIS		"The check mark is set if the object is a mandatory object."
#define ENTRY_DESCRIPTION_STATUSTIP		"Parameter attributes"
#define ENTRY_DESCRIPTION_WHATsTHIS		"..."
#define ENTRY_NAME_STATUSTIP			"Parameter name"
#define ENTRY_NAME_WHATsTHIS			"Name of the parameter."
#define ENTRY_TYPE_STATUSTIP			"Data type"
#define ENTRY_TYPE_WHATsTHIS			"Data type of the parameter."
#define ENTRY_ACCESS_STATUSTIP			"Access type"
#define ENTRY_ACCESS_WHATsTHIS			"Access type of the parameter."
#define ENTRY_RANGE_STATUSTIP			"Value range"
#define ENTRY_RANGE_WHATsTHIS			"Value range of the parameter if given."
#define ENTRY_DEFAULT_STATUSTIP			"Default value"
#define ENTRY_DEFAULT_WHATsTHIS			"Default value of the parameter if given."
#define ENTRY_MANDATORY_STATUSTIP		"If it is a mandatory entry"
#define ENTRY_MANDATORY_WHATsTHIS		"The check mark is set if the entry is a mandatory parameter."
#define ENTRY_MAPPING_STATUSTIP			"If it is mapped into a PDO"
#define ENTRY_MAPPING_WHATsTHIS			"The check mark is set if the entry is mapped into a PDO."
#define ACCESS_STATUSTIP				"Data Access"
#define ACCESS_WHATsTHIS				"..."
#define ACCESS_INPUT_STATUSTIP			"New parameter value"
#define ACCESS_INPUT_WHATsTHIS			"Input field to enter a new parameter value."
#define ACCESS_OUTPUT_STATUSTIP			"Actual parameter value"
#define ACCESS_OUTPUT_WHATsTHIS			"Actual parameter value read from the device."
#define ACCESS_HEX_STATUSTIP			"Display actual value in hexadecimal format"
#define ACCESS_HEX_WHATsTHIS			"Radio button to display the actual parameter value in hexadecimal format."
#define ACCESS_DEC_STATUSTIP			"Display actual value in decimal format"
#define ACCESS_DEC_WHATsTHIS			"Radio button to display the actual parameter value in decimal format."
#define ACCESS_OCT_STATUSTIP			"Display actual value in octal format"
#define ACCESS_OCT_WHATsTHIS			"Radio button to display the actual parameter value in octal format."
#define ACCESS_SEND_STATUSTIP			"Send the entered parameter value"
#define ACCESS_SEND_WHATsTHIS			"Push button to send the entered parameter value to the device."
#define ACCESS_READ_STATUSTIP			"Read the parameter value"
#define ACCESS_READ_WHATsTHIS			"Push button to read the parameter value from the device."
#define DEVICE_INFO_VENDOR_NAME_STATUSTIP		"Vendor name"
#define DEVICE_INFO_VENDOR_NAME_WHATsTHIS		"Name of the vendor."
#define DEVICE_INFO_VENDOR_NUMBER_STATUSTIP		"Vendor number"
#define DEVICE_INFO_VENDOR_NUMBER_WHATsTHIS		"VendorId from CiA."
#define DEVICE_INFO_PRODUCT_NAME_STATUSTIP		"Product name"
#define DEVICE_INFO_PRODUCT_NAME_WHATsTHIS		"Name of the product."
#define DEVICE_INFO_PRODUCT_NUMBER_STATUSTIP	"Product number"
#define DEVICE_INFO_PRODUCT_NUMBER_WHATsTHIS	"Identification of the product."
#define DEVICE_INFO_REVISION_NUMBER_STATUSTIP	"Revision number"
#define DEVICE_INFO_REVISION_NUMBER_WHATsTHIS	"Revision of the device."
#define DEVICE_INFO_ORDER_CODE_STATUSTIP		"Oder code"
#define DEVICE_INFO_ORDER_CODE_WHATsTHIS		"Oder code of the device."
#define DEVICE_INFO_DESCRIPTION_STATUSTIP		"Brief description"
#define DEVICE_INFO_DESCRIPTION_WHATsTHIS		"Description of the device."
#define DEVICE_INFO_BAUDRATE1000_STATUSTIP		"Baud rate index 0"
#define DEVICE_INFO_BAUDRATE1000_WHATsTHIS		"Shows if the given baud rate is supported."
#define DEVICE_INFO_BAUDRATE800_STATUSTIP		"Baud rate index 1"
#define DEVICE_INFO_BAUDRATE800_WHATsTHIS		"Shows if the given baud rate is supported."
#define DEVICE_INFO_BAUDRATE500_STATUSTIP		"Baud rate index 2"
#define DEVICE_INFO_BAUDRATE500_WHATsTHIS		"Shows if the given baud rate is supported."
#define DEVICE_INFO_BAUDRATE250_STATUSTIP		"Baud rate index 3"
#define DEVICE_INFO_BAUDRATE250_WHATsTHIS		"Shows if the given baud rate is supported."
#define DEVICE_INFO_BAUDRATE125_STATUSTIP		"Baud rate index 4"
#define DEVICE_INFO_BAUDRATE125_WHATsTHIS		"Shows if the given baud rate is supported."
#define DEVICE_INFO_BAUDRATE50_STATUSTIP		"Baud rate index 6"
#define DEVICE_INFO_BAUDRATE50_WHATsTHIS		"Shows if the given baud rate is supported."
#define DEVICE_INFO_BAUDRATE20_STATUSTIP		"Baud rate index 7"
#define DEVICE_INFO_BAUDRATE20_WHATsTHIS		"Shows if the given baud rate is supported."
#define DEVICE_INFO_BAUDRATE10_STATUSTIP		"Baud rate index 8"
#define DEVICE_INFO_BAUDRATE10_WHATsTHIS		"Shows if the given baud rate is supported."
#define DEVICE_INFO_BOOTUP_MASTER_STATUSTIP		"Simple boot-up master"
#define DEVICE_INFO_BOOTUP_MASTER_WHATsTHIS		"Shows if the simple boot-up master function is supported."
#define DEVICE_INFO_BOOTUP_SLAVE_STATUSTIP		"Simple boot-up slave"
#define DEVICE_INFO_BOOTUP_SLAVE_WHATsTHIS		"Shows if the simple boot-up master function is supported."
#define DEVICE_INFO_NUMBER_OF_PDOS_STATUSTIP	"Number of PDOs"
#define DEVICE_INFO_NUMBER_OF_PDOS_WHATsTHIS	"Shows the number of Receive PDOs and transmit PDOs."
#define DEVICE_INFO_GRANULARITY_STATUSTIP		"PDO granularity"
#define DEVICE_INFO_GRANULARITY_WHATsTHIS		"Shows the PDO mapping granularity."
#define DEVICE_INFO_DYNAMIC_CHANNELS_STATUSTIP	"Dynamic channels"
#define DEVICE_INFO_DYNAMIC_CHANNELS_WHATsTHIS	"Shows if dynamic channels are supported."
#define DEVICE_INFO_GROUP_MESSAGING_STATUSTIP	"Group Messaging"
#define DEVICE_INFO_GROUP_MESSAGING_WHATsTHIS	"Shows if Group Messaging is supported."
#define DEVICE_INFO_LAYER_SETTINGS_STATUSTIP	"Layer Services and Settings"
#define DEVICE_INFO_LAYER_SETTINGS_WHATsTHIS	"Shows if Layer Services and Settings is supported."
#define DEVICE_INFO_FILE_NAME_STATUSTIP			"File name"
#define DEVICE_INFO_FILE_NAME_WHATsTHIS			"File name of the object dictionary."
#define DEVICE_INFO_FILE_VERSION_STATUSTIP		"File version"
#define DEVICE_INFO_FILE_VERSION_WHATsTHIS		"File version of the object dictionary."
#define DEVICE_INFO_EDS_VERSION_STATUSTIP		"EDS version"
#define DEVICE_INFO_EDS_VERSION_WHATsTHIS		"EDS version of the object dictionary."
#define DEVICE_INFO_AUTHOR_STATUSTIP			"Author"
#define DEVICE_INFO_AUTHOR_WHATsTHIS			"Author of the object dictionary."
#define DEVICE_INFO_COMPANY_STATUSTIP			"Company"
#define DEVICE_INFO_COMPANY_WHATsTHIS			"TBD"
#define DEVICE_INFO_DATE_TIME_STATUSTIP			"Date & time"
#define DEVICE_INFO_DATE_TIME_WHATsTHIS			"Shows date and time of the object dictionary."
#define INIT_INTERFACE_INTERFACE_STATUSTIP		"Interface to initialize"
#define INIT_INTERFACE_INTERFACE_WHATsTHIS		"Enter a interface name or select one fron the list"
#define INIT_INTERFACE_BAUDRATE_STATUSTIP		"Baud rate for CAN communication"
#define INIT_INTERFACE_BAUDRATE_WHATsTHIS		"Select a baud rate for CAN communication."
#define INIT_INTERFACE_MASTER_ID_STATUSTIP		"Node-Id. of the CANopen Master"
#define INIT_INTERFACE_MASTER_ID_WHATsTHIS		"Enter the Node-Id. for the CANopen Master."
#define INIT_INTERFACE_ACCEPT_STATUSTIP			"Accept decisions"
#define INIT_INTERFACE_ACCEPT_WHATsTHIS			"Accept selection and initialize the selected interface."
#define INIT_INTERFACE_CANCEL_STATUSTIP			"Resistance is futile!"
#define INIT_INTERFACE_CANCEL_WHATsTHIS			"Leave without any action."
#define CONNECT_NODE_NODE_LIST_STATUSTIP		"Select a node-id."
#define CONNECT_NODE_NODE_LIST_WHATsTHIS		"Select the node-id. for the device to connect."
#define CONNECT_NODE_NODE_ID_STATUSTIP			"Enter a node-id."
#define CONNECT_NODE_NODE_ID_WHATsTHIS			"Enter the node-id. for the device to connect."
#define CONNECT_NODE_CONNECT_STATUSTIP			"On-line mode "
#define CONNECT_NODE_CONNECT_WHATsTHIS			"Connect the object dictionary to a CANopen device."
#define CONNECT_NODE_OFFLINE_STATUSTIP			"Off-line mode"
#define CONNECT_NODE_OFFLINE_WHATsTHIS			"Operate on the object dictionary in off-line mode."
#define CONNECT_NODE_SEARCH_STATUSTIP			"Search a node"
#define CONNECT_NODE_SEARCH_WHATsTHIS			"Try to find a CANopen Node to connect the object dictionary to."
//#define <resource>_STATUSTIP			""
//#define <resource>_WHATsTHIS			""

#endif // _COPbrowser_h_

//////////////////////////////////////////////////////////////////////////////
//	Uwe Vogt,  UV Software,  Steinaecker 28,  88048 Friedrichshafen,  Germany
//	Fon: +49-7541-6041530, Fax. +49-1803-551809359, Cell fon: +49-170-3801903
//	E-Mail: uwe.vogt@uv-software.de, Internet URL: http://www.uv-software.de/
