////// $URL: http://svn.uv-software.com/opensource/linux/CANopen/COPbrowser/trunc/ConnectNodeDialog.h $
//
//	project   :  COPbrowser - CANopen Object Browser
//	
//	purpose   :  ConnectNodeDialog - Dialog
//	
//	copyright :  (C) 2009, UV Software, Friedrichshafen
//
//	compiler  :  GCC - GNU C++ Compiler (Linux Kernel 2.6)
//
//	export    :  class CConnectNodeDialog
//	
//	includes  :  <includes>
//	
//	author    :  Uwe Vogt, UV Software
//	
//	e-mail    :  uwe.vogt@uv-software.de
//
//////////////////////////////////////////////////////////////////////////////
//	<description>

#ifndef _ConnectNodeDialog_h_
#define _ConnectNodeDialog_h_

//////////////////////////////////////////////////////////////////////////////
//	include-files

#include <qdialog.h>

//////////////////////////////////////////////////////////////////////////////
//	forwarder

class Q3ListBox;
class QSpinBox;
class QPushButton;
class Q3ListBoxItem;

//////////////////////////////////////////////////////////////////////////////
//	class CConnectNodeDialog

class CConnectNodeDialog : public QDialog
{
	Q_OBJECT

	//	attributes:
	private:
		Q3ListBox* m_nodeIdListBox;
		QSpinBox* m_nodeIdSpinBox;
		QPushButton* m_connectPushButton;
		QPushButton* m_offlinePushButton;
		QPushButton* m_searchPushButton;
	private:
		bool m_connectFlag;
	
	//	constructor/destructor:
	public:
		CConnectNodeDialog( QWidget* parent = 0, const char* name = 0 );
		~CConnectNodeDialog();
		
	//	member functions:
	public:
		int  getNodeId();
		bool getConnectFlag();

	private slots:
		void doubleClicked( Q3ListBoxItem * item );
		void acceptConnect();
		void acceptOffline();
		void searchNode();
	
	//	revision control:
	public:
		static const char* version();
};

#endif // _ConnectNodeDialog_h_

//////////////////////////////////////////////////////////////////////////////
//	Uwe Vogt,  UV Software,  Steinaecker 28,  88048 Friedrichshafen,  Germany
//	Fon: +49-7541-6041530, Fax. +49-1803-551809359, Cell fon: +49-170-3801903
//	E-Mail: uwe.vogt@uv-software.de, Internet URL: http://www.uv-software.de/
