//Added by qt3to4:
#include <Q3GridLayout>
////// $URL: http://svn.uv-software.com/opensource/linux/CANopen/COPbrowser/trunc/DeviceInfoDialog.cpp $
//
//	project   :  COPbrowser - CANopen Object Browser
//
//	purpose   :  DeviceInfoDialog - Tab Dialog
//
//	copyright :  (C) 2009, UV Software, Friedrichshafen
//
//	compiler  :  GCC - GNU C++ Compiler (Linux Kernel 2.6)
//
//	export    :  class CDeviceInfoDialog
//
//	includes  :  DeviceInfoDialog.h, COPbrowser.h
//
//	author    :  Uwe Vogt, UV Software
//
//	e-mail    :  uwe.vogt@uv-software.de
//
//////////////////////////////////////////////////////////////////////////////
//	<description>

static const char _id[] = "$Id: DeviceInfoDialog.cpp 56 2009-11-05 18:48:27Z saturn $";

//////////////////////////////////////////////////////////////////////////////
//	include-files

#include "DeviceInfoDialog.h"
#include "COPbrowser.h"
#include <qstring.h>
#include <qlayout.h>
#include <qrect.h>
#include <qlabel.h>
#include <qlineedit.h>
#include <q3whatsthis.h>
#include <qtooltip.h>

//////////////////////////////////////////////////////////////////////////////
//	class CDeviceInfoDialog

CDeviceInfoDialog::CDeviceInfoDialog( QWidget* parent, const char * name )
	: Q3TabDialog( parent, name, FALSE, 0 )
{
	if ( !name )
		setName( "Device Info dialog" );

	//	page 1: Device Info (1)
	QWidget* page1Widget = new QWidget( this, "page 1 widget" );

	QLabel* vendorNameLabel = new QLabel( "Vendor name:", page1Widget, "vendor name text label" );
	m_page1.m_vendorNameLineEdit = new QLineEdit( page1Widget, "vendor name line edit" );
	m_page1.m_vendorNameLineEdit->setPaletteBackgroundColor( paletteBackgroundColor() );
	m_page1.m_vendorNameLineEdit->setFrameShape( QLineEdit::NoFrame );
	m_page1.m_vendorNameLineEdit->setReadOnly( TRUE );
	vendorNameLabel->setBuddy( m_page1.m_vendorNameLineEdit );

	QLabel* vendorNumberLabel = new QLabel( "Vendor number:", page1Widget, "vendor number text label" );
	m_page1.m_vendorNumberLineEdit = new QLineEdit( page1Widget, "vendor number line edit" );
	m_page1.m_vendorNumberLineEdit->setPaletteBackgroundColor( paletteBackgroundColor() );
	m_page1.m_vendorNumberLineEdit->setFrameShape( QLineEdit::NoFrame );
	m_page1.m_vendorNumberLineEdit->setReadOnly( TRUE );
	vendorNumberLabel->setBuddy( m_page1.m_vendorNumberLineEdit );

	QLabel* productNameLabel = new QLabel( "Product name:", page1Widget, "product name text label" );
	m_page1.m_productNameLineEdit = new QLineEdit( page1Widget, "product name line edit" );
	m_page1.m_productNameLineEdit->setPaletteBackgroundColor( paletteBackgroundColor() );
	m_page1.m_productNameLineEdit->setFrameShape( QLineEdit::NoFrame );
	m_page1.m_productNameLineEdit->setReadOnly( TRUE );
	productNameLabel->setBuddy( m_page1.m_productNameLineEdit );

	QLabel* productNumberLabel = new QLabel( "Product number:", page1Widget, "product number text label" );
	m_page1.m_productNumberLineEdit = new QLineEdit( page1Widget, "product number line edit" );
	m_page1.m_productNumberLineEdit->setPaletteBackgroundColor( paletteBackgroundColor() );
	m_page1.m_productNumberLineEdit->setFrameShape( QLineEdit::NoFrame );
	m_page1.m_productNumberLineEdit->setReadOnly( TRUE );
	productNumberLabel->setBuddy( m_page1.m_productNumberLineEdit );

	QLabel* revisionNumberLabel = new QLabel( "Revision number:", page1Widget, "revision number text label" );
	m_page1.m_revisionNumberLineEdit = new QLineEdit( page1Widget, "revision number line edit" );
	m_page1.m_revisionNumberLineEdit->setPaletteBackgroundColor( paletteBackgroundColor() );
	m_page1.m_revisionNumberLineEdit->setFrameShape( QLineEdit::NoFrame );
	m_page1.m_revisionNumberLineEdit->setReadOnly( TRUE );
	revisionNumberLabel->setBuddy( m_page1.m_revisionNumberLineEdit );

	QLabel* orderCodeLabel = new QLabel( "Order code:", page1Widget, "order code text label" );
	m_page1.m_orderCodeLineEdit = new QLineEdit( page1Widget, "order code line edit" );
	m_page1.m_orderCodeLineEdit->setPaletteBackgroundColor( paletteBackgroundColor() );
	m_page1.m_orderCodeLineEdit->setFrameShape( QLineEdit::NoFrame );
	m_page1.m_orderCodeLineEdit->setReadOnly( TRUE );
	orderCodeLabel->setBuddy( m_page1.m_orderCodeLineEdit );

	QLabel* descriptionLabel = new QLabel( "Description:", page1Widget, "description text label" );
	m_page1.m_descriptionLineEdit = new QLineEdit( page1Widget, "description line edit" );
	m_page1.m_descriptionLineEdit->setPaletteBackgroundColor( paletteBackgroundColor() );
	m_page1.m_descriptionLineEdit->setFrameShape( QLineEdit::NoFrame );
	m_page1.m_descriptionLineEdit->setReadOnly( TRUE );
	descriptionLabel->setBuddy( m_page1.m_descriptionLineEdit );

	Q3GridLayout* page1WidgetLayout = new Q3GridLayout( page1Widget, 7, 2, 11, 6 );
	page1WidgetLayout->setAlignment( Qt::AlignTop );
	page1WidgetLayout->addWidget( vendorNameLabel, 0, 0 );
	page1WidgetLayout->addWidget( vendorNumberLabel, 1, 0 );
	page1WidgetLayout->addWidget( productNameLabel, 2, 0 );
	page1WidgetLayout->addWidget( productNumberLabel, 3, 0 );
	page1WidgetLayout->addWidget( revisionNumberLabel, 4, 0 );
	page1WidgetLayout->addWidget( orderCodeLabel, 5, 0 );
	page1WidgetLayout->addWidget( descriptionLabel, 6, 0 );
	page1WidgetLayout->addWidget( m_page1.m_vendorNameLineEdit, 0, 1 );
	page1WidgetLayout->addWidget( m_page1.m_vendorNumberLineEdit, 1, 1 );
	page1WidgetLayout->addWidget( m_page1.m_productNameLineEdit, 2, 1 );
	page1WidgetLayout->addWidget( m_page1.m_productNumberLineEdit, 3, 1 );
	page1WidgetLayout->addWidget( m_page1.m_revisionNumberLineEdit, 4, 1 );
	page1WidgetLayout->addWidget( m_page1.m_orderCodeLineEdit, 5, 1 );
	page1WidgetLayout->addWidget( m_page1.m_descriptionLineEdit, 6, 1 );

	addTab( page1Widget, "Device Info (1)" );

	//	page 2: Device Info (2)
	QWidget* page2Widget = new QWidget( this, "page 2 widget" );

	QLabel* baudrateLabel = new QLabel( "Baud rate:", page2Widget, "baudrate text label" );
	m_page2.m_baudrate1000LineEdit = new QLineEdit( page2Widget, "baudrate 1000 line edit" );
	m_page2.m_baudrate1000LineEdit->setPaletteBackgroundColor( paletteBackgroundColor() );
	m_page2.m_baudrate1000LineEdit->setFrameShape( QLineEdit::NoFrame );
	m_page2.m_baudrate1000LineEdit->setReadOnly( TRUE );

	m_page2.m_baudrate800LineEdit = new QLineEdit( page2Widget, "baudrate 800 line edit" );
	m_page2.m_baudrate800LineEdit->setPaletteBackgroundColor( paletteBackgroundColor() );
	m_page2.m_baudrate800LineEdit->setFrameShape( QLineEdit::NoFrame );
	m_page2.m_baudrate800LineEdit->setReadOnly( TRUE );

	m_page2.m_baudrate500LineEdit = new QLineEdit( page2Widget, "baudrate 500 line edit" );
	m_page2.m_baudrate500LineEdit->setPaletteBackgroundColor( paletteBackgroundColor() );
	m_page2.m_baudrate500LineEdit->setFrameShape( QLineEdit::NoFrame );
	m_page2.m_baudrate500LineEdit->setReadOnly( TRUE );

	m_page2.m_baudrate250LineEdit = new QLineEdit( page2Widget, "baudrate 250 line edit" );
	m_page2.m_baudrate250LineEdit->setPaletteBackgroundColor( paletteBackgroundColor() );
	m_page2.m_baudrate250LineEdit->setFrameShape( QLineEdit::NoFrame );
	m_page2.m_baudrate250LineEdit->setReadOnly( TRUE );

	m_page2.m_baudrate125LineEdit = new QLineEdit( page2Widget, "baudrate 125 line edit" );
	m_page2.m_baudrate125LineEdit->setPaletteBackgroundColor( paletteBackgroundColor() );
	m_page2.m_baudrate125LineEdit->setFrameShape( QLineEdit::NoFrame );
	m_page2.m_baudrate125LineEdit->setReadOnly( TRUE );

	m_page2.m_baudrate50LineEdit = new QLineEdit( page2Widget, "baudrate 50 line edit" );
	m_page2.m_baudrate50LineEdit->setPaletteBackgroundColor( paletteBackgroundColor() );
	m_page2.m_baudrate50LineEdit->setFrameShape( QLineEdit::NoFrame );
	m_page2.m_baudrate50LineEdit->setReadOnly( TRUE );

	m_page2.m_baudrate20LineEdit = new QLineEdit( page2Widget, "baudrate 20 line edit" );
	m_page2.m_baudrate20LineEdit->setPaletteBackgroundColor( paletteBackgroundColor() );
	m_page2.m_baudrate20LineEdit->setFrameShape( QLineEdit::NoFrame );
	m_page2.m_baudrate20LineEdit->setReadOnly( TRUE );

	m_page2.m_baudrate10LineEdit = new QLineEdit( page2Widget, "baudrate 10 line edit" );
	m_page2.m_baudrate10LineEdit->setPaletteBackgroundColor( paletteBackgroundColor() );
	m_page2.m_baudrate10LineEdit->setFrameShape( QLineEdit::NoFrame );
	m_page2.m_baudrate10LineEdit->setReadOnly( TRUE );

	Q3GridLayout* page2WidgetLayout = new Q3GridLayout( page2Widget, 8, 2, 11, 6 );
	page2WidgetLayout->setAlignment( Qt::AlignTop );
	page2WidgetLayout->addWidget( baudrateLabel, 0, 0 );
	page2WidgetLayout->addWidget( m_page2.m_baudrate1000LineEdit, 0, 1 );
	page2WidgetLayout->addWidget( m_page2.m_baudrate800LineEdit, 1, 1 );
	page2WidgetLayout->addWidget( m_page2.m_baudrate500LineEdit, 2, 1 );
	page2WidgetLayout->addWidget( m_page2.m_baudrate250LineEdit, 3, 1 );
	page2WidgetLayout->addWidget( m_page2.m_baudrate125LineEdit, 4, 1 );
	page2WidgetLayout->addWidget( m_page2.m_baudrate50LineEdit, 5, 1 );
	page2WidgetLayout->addWidget( m_page2.m_baudrate20LineEdit, 6, 1 );
	page2WidgetLayout->addWidget( m_page2.m_baudrate10LineEdit, 7, 1 );

	addTab( page2Widget, "DeviceInfo (2)" );

	//	page 3: Device Info (3)
	QWidget* page3Widget = new QWidget( this, "page 3 widget" );

	QLabel* bootupMasterLabel = new QLabel( "Simple boot-up master:", page3Widget, "bootup master text label" );
	m_page3.m_bootupMasterLineEdit = new QLineEdit( page3Widget, "bootup master line edit" );
	m_page3.m_bootupMasterLineEdit->setPaletteBackgroundColor( paletteBackgroundColor() );
	m_page3.m_bootupMasterLineEdit->setFrameShape( QLineEdit::NoFrame );
	m_page3.m_bootupMasterLineEdit->setReadOnly( TRUE );
	bootupMasterLabel->setBuddy( m_page3.m_bootupMasterLineEdit );

	QLabel* bootupSlaveLabel = new QLabel( "Simple boot-up slave:", page3Widget, "bootup slave text label" );
	m_page3.m_bootupSlaveLineEdit = new QLineEdit( page3Widget, "bootup slave line edit" );
	m_page3.m_bootupSlaveLineEdit->setPaletteBackgroundColor( paletteBackgroundColor() );
	m_page3.m_bootupSlaveLineEdit->setFrameShape( QLineEdit::NoFrame );
	m_page3.m_bootupSlaveLineEdit->setReadOnly( TRUE );
	bootupSlaveLabel->setBuddy( m_page3.m_bootupSlaveLineEdit );

	QLabel* numberOfPDOsLabel = new QLabel( "Number of PDOs:", page3Widget, "number of PDOs text label" );
	m_page3.m_numberOfPDOsLineEdit = new QLineEdit( page3Widget, "number of PDOs line edit" );
	m_page3.m_numberOfPDOsLineEdit->setPaletteBackgroundColor( paletteBackgroundColor() );
	m_page3.m_numberOfPDOsLineEdit->setFrameShape( QLineEdit::NoFrame );
	m_page3.m_numberOfPDOsLineEdit->setReadOnly( TRUE );
	numberOfPDOsLabel->setBuddy( m_page3.m_numberOfPDOsLineEdit );

	QLabel* granularityLabel = new QLabel( "Granularity:", page3Widget, "granularity text label" );
	m_page3.m_granularityLineEdit = new QLineEdit( page3Widget, "granularity line edit" );
	m_page3.m_granularityLineEdit->setPaletteBackgroundColor( paletteBackgroundColor() );
	m_page3.m_granularityLineEdit->setFrameShape( QLineEdit::NoFrame );
	m_page3.m_granularityLineEdit->setReadOnly( TRUE );
	granularityLabel->setBuddy( m_page3.m_granularityLineEdit );

	QLabel* dynamicChannelsLabel = new QLabel( "Dynamic channels:", page3Widget, "dynamic channels text label" );
	m_page3.m_dynamicChannelsLineEdit = new QLineEdit( page3Widget, "dynamic channels line edit" );
	m_page3.m_dynamicChannelsLineEdit->setPaletteBackgroundColor( paletteBackgroundColor() );
	m_page3.m_dynamicChannelsLineEdit->setFrameShape( QLineEdit::NoFrame );
	m_page3.m_dynamicChannelsLineEdit->setReadOnly( TRUE );
	dynamicChannelsLabel->setBuddy( m_page3.m_dynamicChannelsLineEdit );

	QLabel* groupMessagingLabel = new QLabel( "Group messaging:", page3Widget, "group messaging text label" );
	m_page3.m_groupMessagingLineEdit = new QLineEdit( page3Widget, "group messaging line edit" );
	m_page3.m_groupMessagingLineEdit->setPaletteBackgroundColor( paletteBackgroundColor() );
	m_page3.m_groupMessagingLineEdit->setFrameShape( QLineEdit::NoFrame );
	m_page3.m_groupMessagingLineEdit->setReadOnly( TRUE );
	groupMessagingLabel->setBuddy( m_page3.m_groupMessagingLineEdit );

	QLabel* layerSettingsLabel = new QLabel( "Layer settings (LSS):", page3Widget, "layer settings text label" );
	m_page3.m_layerSettingsLineEdit = new QLineEdit( page3Widget, "layer settings line edit" );
	m_page3.m_layerSettingsLineEdit->setPaletteBackgroundColor( paletteBackgroundColor() );
	m_page3.m_layerSettingsLineEdit->setFrameShape( QLineEdit::NoFrame );
	m_page3.m_layerSettingsLineEdit->setReadOnly( TRUE );
	layerSettingsLabel->setBuddy( m_page3.m_layerSettingsLineEdit );

	Q3GridLayout* page3WidgetLayout = new Q3GridLayout( page3Widget, 7, 2, 11, 6 );
	page3WidgetLayout->setAlignment( Qt::AlignTop );
	page3WidgetLayout->addWidget( bootupMasterLabel, 0, 0 );
	page3WidgetLayout->addWidget( bootupSlaveLabel, 1, 0 );
	page3WidgetLayout->addWidget( numberOfPDOsLabel, 2, 0 );
	page3WidgetLayout->addWidget( granularityLabel, 3, 0 );
	page3WidgetLayout->addWidget( dynamicChannelsLabel, 4, 0 );
	page3WidgetLayout->addWidget( groupMessagingLabel, 5, 0 );
	page3WidgetLayout->addWidget( layerSettingsLabel, 6, 0 );
	page3WidgetLayout->addWidget( m_page3.m_bootupMasterLineEdit, 0, 1 );
	page3WidgetLayout->addWidget( m_page3.m_bootupSlaveLineEdit, 1, 1 );
	page3WidgetLayout->addWidget( m_page3.m_numberOfPDOsLineEdit, 2, 1 );
	page3WidgetLayout->addWidget( m_page3.m_granularityLineEdit, 3, 1 );
	page3WidgetLayout->addWidget( m_page3.m_dynamicChannelsLineEdit, 4, 1 );
	page3WidgetLayout->addWidget( m_page3.m_groupMessagingLineEdit, 5, 1 );
	page3WidgetLayout->addWidget( m_page3.m_layerSettingsLineEdit, 6, 1 );

	addTab( page3Widget, "DeviceInfo (3)" );

	//	page 4: File Info
	QWidget* page4Widget = new QWidget( this, "page 4 widget" );

	QLabel* fileNameLabel = new QLabel( "File name:", page4Widget, "file name text label" );
	m_page4.m_fileNameLineEdit = new QLineEdit( page4Widget, "file name line edit" );
	m_page4.m_fileNameLineEdit->setPaletteBackgroundColor( paletteBackgroundColor() );
	m_page4.m_fileNameLineEdit->setFrameShape( QLineEdit::NoFrame );
	m_page4.m_fileNameLineEdit->setReadOnly( TRUE );
	fileNameLabel->setBuddy( m_page4.m_fileNameLineEdit );

	QLabel* fileVersionLabel = new QLabel( "File version:", page4Widget, "file version text label" );
	m_page4.m_fileVersionLineEdit = new QLineEdit( page4Widget, "file version line edit" );
	m_page4.m_fileVersionLineEdit->setPaletteBackgroundColor( paletteBackgroundColor() );
	m_page4.m_fileVersionLineEdit->setFrameShape( QLineEdit::NoFrame );
	m_page4.m_fileVersionLineEdit->setReadOnly( TRUE );
	fileVersionLabel->setBuddy( m_page4.m_fileVersionLineEdit );

	QLabel* EDSVersionLabel = new QLabel( "EDS version:", page4Widget, "EDS version text label" );
	m_page4.m_EDSVersionLineEdit = new QLineEdit( page4Widget, "EDS version line edit" );
	m_page4.m_EDSVersionLineEdit->setPaletteBackgroundColor( paletteBackgroundColor() );
	m_page4.m_EDSVersionLineEdit->setFrameShape( QLineEdit::NoFrame );
	m_page4.m_EDSVersionLineEdit->setReadOnly( TRUE );
	EDSVersionLabel->setBuddy( m_page4.m_EDSVersionLineEdit );

	QLabel* authorLabel = new QLabel( "Author:", page4Widget, "author text label" );
	m_page4.m_authorLineEdit = new QLineEdit( page4Widget, "author line edit" );
	m_page4.m_authorLineEdit->setPaletteBackgroundColor( paletteBackgroundColor() );
	m_page4.m_authorLineEdit->setFrameShape( QLineEdit::NoFrame );
	m_page4.m_authorLineEdit->setReadOnly( TRUE );
	authorLabel->setBuddy( m_page4.m_authorLineEdit );

	QLabel* companyLabel = new QLabel( "Company:", page4Widget, "company text label" );
	m_page4.m_companyLineEdit = new QLineEdit( page4Widget, "company line edit" );
	m_page4.m_companyLineEdit->setPaletteBackgroundColor( paletteBackgroundColor() );
	m_page4.m_companyLineEdit->setFrameShape( QLineEdit::NoFrame );
	m_page4.m_companyLineEdit->setReadOnly( TRUE );
	companyLabel->setBuddy( m_page4.m_companyLineEdit );

	QLabel* dateLabel = new QLabel( "Date:", page4Widget, "date text label" );
	m_page4.m_dateLineEdit = new QLineEdit( page4Widget, "date line edit" );
	m_page4.m_dateLineEdit->setPaletteBackgroundColor( paletteBackgroundColor() );
	m_page4.m_dateLineEdit->setFrameShape( QLineEdit::NoFrame );
	m_page4.m_dateLineEdit->setReadOnly( TRUE );
	dateLabel->setBuddy( m_page4.m_dateLineEdit );

	QLabel* describingLabel = new QLabel( "Description:", page4Widget, "description text label" );
	m_page4.m_descriptionLineEdit = new QLineEdit( page4Widget, "description line edit" );
	m_page4.m_descriptionLineEdit->setPaletteBackgroundColor( paletteBackgroundColor() );
	m_page4.m_descriptionLineEdit->setFrameShape( QLineEdit::NoFrame );
	m_page4.m_descriptionLineEdit->setReadOnly( TRUE );
	describingLabel->setBuddy( m_page4.m_descriptionLineEdit );

	Q3GridLayout* page4WidgetLayout = new Q3GridLayout( page4Widget, 7, 2, 11, 6 );
	page4WidgetLayout->setAlignment( Qt::AlignTop );
	page4WidgetLayout->addWidget( fileNameLabel, 0, 0 );
	page4WidgetLayout->addWidget( fileVersionLabel, 1, 0 );
	page4WidgetLayout->addWidget( EDSVersionLabel, 2, 0 );
	page4WidgetLayout->addWidget( authorLabel, 3, 0 );
	page4WidgetLayout->addWidget( companyLabel, 4, 0 );
	page4WidgetLayout->addWidget( dateLabel, 5, 0 );
	page4WidgetLayout->addWidget( describingLabel, 6, 0 );
	page4WidgetLayout->addWidget( m_page4.m_fileNameLineEdit, 0, 1 );
	page4WidgetLayout->addWidget( m_page4.m_fileVersionLineEdit, 1, 1 );
	page4WidgetLayout->addWidget( m_page4.m_EDSVersionLineEdit, 2, 1 );
	page4WidgetLayout->addWidget( m_page4.m_authorLineEdit, 3, 1 );
	page4WidgetLayout->addWidget( m_page4.m_companyLineEdit, 4, 1 );
	page4WidgetLayout->addWidget( m_page4.m_dateLineEdit, 5, 1 );
	page4WidgetLayout->addWidget( m_page4.m_descriptionLineEdit, 6, 1 );

	addTab( page4Widget, "File Info" );

	// tool tip
	QToolTip::add( m_page1.m_vendorNameLineEdit, DEVICE_INFO_VENDOR_NAME_STATUSTIP );
	QToolTip::add( m_page1.m_vendorNumberLineEdit, DEVICE_INFO_VENDOR_NUMBER_STATUSTIP );
	QToolTip::add( m_page1.m_productNameLineEdit, DEVICE_INFO_PRODUCT_NAME_STATUSTIP );
	QToolTip::add( m_page1.m_productNumberLineEdit, DEVICE_INFO_PRODUCT_NUMBER_STATUSTIP );
	QToolTip::add( m_page1.m_revisionNumberLineEdit, DEVICE_INFO_REVISION_NUMBER_STATUSTIP );
	QToolTip::add( m_page1.m_orderCodeLineEdit, DEVICE_INFO_ORDER_CODE_STATUSTIP );
	QToolTip::add( m_page1.m_descriptionLineEdit, DEVICE_INFO_DESCRIPTION_STATUSTIP );
	QToolTip::add( m_page2.m_baudrate1000LineEdit, DEVICE_INFO_BAUDRATE1000_STATUSTIP );
	QToolTip::add( m_page2.m_baudrate800LineEdit, DEVICE_INFO_BAUDRATE800_STATUSTIP );
	QToolTip::add( m_page2.m_baudrate500LineEdit, DEVICE_INFO_BAUDRATE500_STATUSTIP );
	QToolTip::add( m_page2.m_baudrate250LineEdit, DEVICE_INFO_BAUDRATE250_STATUSTIP );
	QToolTip::add( m_page2.m_baudrate125LineEdit, DEVICE_INFO_BAUDRATE125_STATUSTIP );
	QToolTip::add( m_page2.m_baudrate50LineEdit, DEVICE_INFO_BAUDRATE50_STATUSTIP );
	QToolTip::add( m_page2.m_baudrate20LineEdit, DEVICE_INFO_BAUDRATE20_STATUSTIP );
	QToolTip::add( m_page2.m_baudrate10LineEdit, DEVICE_INFO_BAUDRATE10_STATUSTIP );
	QToolTip::add( m_page3.m_bootupMasterLineEdit, DEVICE_INFO_BOOTUP_MASTER_STATUSTIP );
	QToolTip::add( m_page3.m_bootupSlaveLineEdit, DEVICE_INFO_BOOTUP_SLAVE_STATUSTIP );
	QToolTip::add( m_page3.m_numberOfPDOsLineEdit, DEVICE_INFO_NUMBER_OF_PDOS_STATUSTIP );
	QToolTip::add( m_page3.m_granularityLineEdit, DEVICE_INFO_GRANULARITY_STATUSTIP );
	QToolTip::add( m_page3.m_dynamicChannelsLineEdit, DEVICE_INFO_DYNAMIC_CHANNELS_STATUSTIP );
	QToolTip::add( m_page3.m_groupMessagingLineEdit, DEVICE_INFO_GROUP_MESSAGING_STATUSTIP );
	QToolTip::add( m_page3.m_layerSettingsLineEdit, DEVICE_INFO_LAYER_SETTINGS_STATUSTIP );
	QToolTip::add( m_page4.m_fileNameLineEdit, DEVICE_INFO_FILE_NAME_STATUSTIP );
	QToolTip::add( m_page4.m_fileVersionLineEdit, DEVICE_INFO_FILE_VERSION_STATUSTIP );
	QToolTip::add( m_page4.m_EDSVersionLineEdit, DEVICE_INFO_EDS_VERSION_STATUSTIP );
	QToolTip::add( m_page4.m_authorLineEdit, DEVICE_INFO_AUTHOR_STATUSTIP );
	QToolTip::add( m_page4.m_companyLineEdit, DEVICE_INFO_COMPANY_STATUSTIP );
	QToolTip::add( m_page4.m_dateLineEdit, DEVICE_INFO_DATE_TIME_STATUSTIP );
	QToolTip::add( m_page4.m_descriptionLineEdit, DEVICE_INFO_DESCRIPTION_STATUSTIP );

	// context help
	Q3WhatsThis::add( vendorNameLabel, DEVICE_INFO_VENDOR_NAME_WHATsTHIS );
	Q3WhatsThis::add( vendorNumberLabel, DEVICE_INFO_VENDOR_NUMBER_WHATsTHIS );
	Q3WhatsThis::add( productNameLabel, DEVICE_INFO_PRODUCT_NAME_WHATsTHIS );
	Q3WhatsThis::add( productNumberLabel, DEVICE_INFO_PRODUCT_NUMBER_WHATsTHIS );
	Q3WhatsThis::add( revisionNumberLabel, DEVICE_INFO_REVISION_NUMBER_WHATsTHIS );
	Q3WhatsThis::add( orderCodeLabel, DEVICE_INFO_ORDER_CODE_WHATsTHIS );
	Q3WhatsThis::add( descriptionLabel, DEVICE_INFO_DESCRIPTION_WHATsTHIS );
	//QWhatsThis::add( baudrateLabel, DEVICE_INFO_BAUDRATE1000_WHATsTHIS );
	Q3WhatsThis::add( bootupMasterLabel, DEVICE_INFO_BOOTUP_MASTER_WHATsTHIS );
	Q3WhatsThis::add( bootupSlaveLabel, DEVICE_INFO_BOOTUP_SLAVE_WHATsTHIS );
	Q3WhatsThis::add( numberOfPDOsLabel, DEVICE_INFO_NUMBER_OF_PDOS_WHATsTHIS );
	Q3WhatsThis::add( granularityLabel, DEVICE_INFO_GRANULARITY_WHATsTHIS );
	Q3WhatsThis::add( dynamicChannelsLabel, DEVICE_INFO_DYNAMIC_CHANNELS_WHATsTHIS );
	Q3WhatsThis::add( groupMessagingLabel, DEVICE_INFO_GROUP_MESSAGING_WHATsTHIS );
	Q3WhatsThis::add( layerSettingsLabel, DEVICE_INFO_LAYER_SETTINGS_WHATsTHIS );
	Q3WhatsThis::add( fileNameLabel, DEVICE_INFO_FILE_NAME_WHATsTHIS );
	Q3WhatsThis::add( fileVersionLabel, DEVICE_INFO_FILE_VERSION_WHATsTHIS );
	Q3WhatsThis::add( EDSVersionLabel, DEVICE_INFO_EDS_VERSION_WHATsTHIS );
	Q3WhatsThis::add( authorLabel, DEVICE_INFO_AUTHOR_WHATsTHIS );
	Q3WhatsThis::add( companyLabel, DEVICE_INFO_COMPANY_WHATsTHIS );
	Q3WhatsThis::add( dateLabel, DEVICE_INFO_DATE_TIME_WHATsTHIS );
	Q3WhatsThis::add( describingLabel, DEVICE_INFO_DESCRIPTION_WHATsTHIS );
	Q3WhatsThis::add( m_page1.m_vendorNameLineEdit, DEVICE_INFO_VENDOR_NAME_WHATsTHIS );
	Q3WhatsThis::add( m_page1.m_vendorNumberLineEdit, DEVICE_INFO_VENDOR_NUMBER_WHATsTHIS );
	Q3WhatsThis::add( m_page1.m_productNameLineEdit, DEVICE_INFO_PRODUCT_NAME_WHATsTHIS );
	Q3WhatsThis::add( m_page1.m_productNumberLineEdit, DEVICE_INFO_PRODUCT_NUMBER_WHATsTHIS );
	Q3WhatsThis::add( m_page1.m_revisionNumberLineEdit, DEVICE_INFO_REVISION_NUMBER_WHATsTHIS );
	Q3WhatsThis::add( m_page1.m_orderCodeLineEdit, DEVICE_INFO_ORDER_CODE_WHATsTHIS );
	Q3WhatsThis::add( m_page1.m_descriptionLineEdit, DEVICE_INFO_DESCRIPTION_WHATsTHIS );
	Q3WhatsThis::add( m_page2.m_baudrate1000LineEdit, DEVICE_INFO_BAUDRATE1000_WHATsTHIS );
	Q3WhatsThis::add( m_page2.m_baudrate800LineEdit, DEVICE_INFO_BAUDRATE800_WHATsTHIS );
	Q3WhatsThis::add( m_page2.m_baudrate500LineEdit, DEVICE_INFO_BAUDRATE500_WHATsTHIS );
	Q3WhatsThis::add( m_page2.m_baudrate250LineEdit, DEVICE_INFO_BAUDRATE250_WHATsTHIS );
	Q3WhatsThis::add( m_page2.m_baudrate125LineEdit, DEVICE_INFO_BAUDRATE125_WHATsTHIS );
	Q3WhatsThis::add( m_page2.m_baudrate50LineEdit, DEVICE_INFO_BAUDRATE50_WHATsTHIS );
	Q3WhatsThis::add( m_page2.m_baudrate20LineEdit, DEVICE_INFO_BAUDRATE20_WHATsTHIS );
	Q3WhatsThis::add( m_page2.m_baudrate10LineEdit, DEVICE_INFO_BAUDRATE10_WHATsTHIS );
	Q3WhatsThis::add( m_page3.m_bootupMasterLineEdit, DEVICE_INFO_BOOTUP_MASTER_WHATsTHIS );
	Q3WhatsThis::add( m_page3.m_bootupSlaveLineEdit, DEVICE_INFO_BOOTUP_SLAVE_WHATsTHIS );
	Q3WhatsThis::add( m_page3.m_numberOfPDOsLineEdit, DEVICE_INFO_NUMBER_OF_PDOS_WHATsTHIS );
	Q3WhatsThis::add( m_page3.m_granularityLineEdit, DEVICE_INFO_GRANULARITY_WHATsTHIS );
	Q3WhatsThis::add( m_page3.m_dynamicChannelsLineEdit, DEVICE_INFO_DYNAMIC_CHANNELS_WHATsTHIS );
	Q3WhatsThis::add( m_page3.m_groupMessagingLineEdit, DEVICE_INFO_GROUP_MESSAGING_WHATsTHIS );
	Q3WhatsThis::add( m_page3.m_layerSettingsLineEdit, DEVICE_INFO_LAYER_SETTINGS_WHATsTHIS );
	Q3WhatsThis::add( m_page4.m_fileNameLineEdit, DEVICE_INFO_FILE_NAME_WHATsTHIS );
	Q3WhatsThis::add( m_page4.m_fileVersionLineEdit, DEVICE_INFO_FILE_VERSION_WHATsTHIS );
	Q3WhatsThis::add( m_page4.m_EDSVersionLineEdit, DEVICE_INFO_EDS_VERSION_WHATsTHIS );
	Q3WhatsThis::add( m_page4.m_authorLineEdit, DEVICE_INFO_AUTHOR_WHATsTHIS );
	Q3WhatsThis::add( m_page4.m_companyLineEdit, DEVICE_INFO_COMPANY_WHATsTHIS );
	Q3WhatsThis::add( m_page4.m_dateLineEdit, DEVICE_INFO_DATE_TIME_WHATsTHIS );
	Q3WhatsThis::add( m_page4.m_descriptionLineEdit, DEVICE_INFO_DESCRIPTION_WHATsTHIS );

	// resize the dialog box
	QRect rect = geometry();
	//rect.setWidth( (rect.width() * 17) / 10 );	//@ToDo: resize to fit!
	resize( QSize(rect.width(), rect.height())/*.expandedTo(minimumSizeHint())*/ );
}

CDeviceInfoDialog::~CDeviceInfoDialog()
{
}

bool CDeviceInfoDialog::populate( CCANopen* dictionary )
{
	Q_ASSERT( dictionary );

	bool success = false;

	if( dictionary->m_deviceInfo )
	{
		m_page1.m_vendorNameLineEdit->setText( dictionary->m_deviceInfo->getVendorName() );
		m_page1.m_vendorNumberLineEdit->setText( QString( "%1" )
				.arg( dictionary->m_deviceInfo->getVendorNumber() ) );
		m_page1.m_productNameLineEdit->setText( dictionary->m_deviceInfo->getProductName() );
		m_page1.m_productNumberLineEdit->setText( QString( "%1" )
				.arg( dictionary->m_deviceInfo->getProductNumber() ) );
		m_page1.m_revisionNumberLineEdit->setText( QString( "%1.%2" )
				.arg( (dictionary->m_deviceInfo->getRevisionNumber() & 0xFFFF0000UL) >> 16 )
				.arg( (dictionary->m_deviceInfo->getRevisionNumber() & 0x0000FFFFUL) >> 0 ) );
		m_page1.m_orderCodeLineEdit->setText( dictionary->m_deviceInfo->getOrderCode() );
		m_page1.m_descriptionLineEdit->setText( dictionary->m_deviceInfo->getDescription() );

		m_page2.m_baudrate1000LineEdit->setText( QString( "1.0 MBit/s  %1 supported" )
				.arg( dictionary->m_deviceInfo->getBaudrate( CCANopenDeviceInfo::baudrate1000 )? "is" : "is not" ) );
		m_page2.m_baudrate800LineEdit->setText( QString( "800 kBit/s  %1 supported" )
				.arg( dictionary->m_deviceInfo->getBaudrate( CCANopenDeviceInfo::baudrate800 )? "is" : "is not" ) );
		m_page2.m_baudrate500LineEdit->setText( QString( "500 kBit/s  %1 supported" )
				.arg( dictionary->m_deviceInfo->getBaudrate( CCANopenDeviceInfo::baudrate500 )? "is" : "is not" ) );
		m_page2.m_baudrate250LineEdit->setText( QString( "250 kBit/s  %1 supported" )
				.arg( dictionary->m_deviceInfo->getBaudrate( CCANopenDeviceInfo::baudrate250 )? "is" : "is not" ) );
		m_page2.m_baudrate125LineEdit->setText( QString( "125 kBit/s  %1 supported" )
				.arg( dictionary->m_deviceInfo->getBaudrate( CCANopenDeviceInfo::baudrate125 )? "is" : "is not" ) );
		m_page2.m_baudrate50LineEdit->setText( QString( "50 kBit/s  %1 supported" )
				.arg( dictionary->m_deviceInfo->getBaudrate( CCANopenDeviceInfo::baudrate50 )? "is" : "is not" ) );
		m_page2.m_baudrate20LineEdit->setText( QString( "20 kBit/s  %1 supported" )
				.arg( dictionary->m_deviceInfo->getBaudrate( CCANopenDeviceInfo::baudrate20 )? "is" : "is not" ) );
		m_page2.m_baudrate10LineEdit->setText( QString( "10 kBit/s  %1 supported" )
				.arg( dictionary->m_deviceInfo->getBaudrate( CCANopenDeviceInfo::baudrate10 )? "is" : "is not" ) );

		m_page3.m_bootupMasterLineEdit->setText( QString( "%1 supported" )
				.arg( dictionary->m_deviceInfo->getSimpleBootUpMaster()? "is" : "is not" ) );
		m_page3.m_bootupSlaveLineEdit->setText( QString( "%1 supported" ).
				arg( dictionary->m_deviceInfo->getSimpleBootUpSlave()? "is" : "is not" ) );
		m_page3.m_numberOfPDOsLineEdit->setText( QString( "%1 RxPDO(s) and %2 TxPDO(s) supported" )
				.arg( dictionary->m_deviceInfo->getNumberOfRxPDO() )
				.arg( dictionary->m_deviceInfo->getNumberOfTxPDO() ) );
		m_page3.m_granularityLineEdit->setText( QString( "%1 - %2" )
				.arg( dictionary->m_deviceInfo->getPDOGranularity() )
				.arg( dictionary->m_deviceInfo->getPDOGranularity()? "dynamic mapping supported"
																   : "mapping not modifiable" ) );
		m_page3.m_dynamicChannelsLineEdit->setText( QString( "%1 supported" )
				.arg( dictionary->m_deviceInfo->getDynamicChannels()? "is" : "is not" ) );
		m_page3.m_groupMessagingLineEdit->setText( QString( "%1 supported" )
				.arg( dictionary->m_deviceInfo->getGroupMessaging()? "is" : "is not" ) );
		m_page3.m_layerSettingsLineEdit->setText( QString( "%1 supported" )
				.arg( dictionary->m_deviceInfo->getLayerSettings()? "is" : "is not" ) );

		success = true;
	}
	m_page4.m_fileNameLineEdit->setText( dictionary->getFileName() );
	m_page4.m_fileVersionLineEdit->setText( dictionary->getRevision() );
	m_page4.m_EDSVersionLineEdit->setText( dictionary->m_deviceInfo? dictionary->m_deviceInfo->getEDSVersion() : "3.0" );
	m_page4.m_authorLineEdit->setText( dictionary->getAuthor() );
	m_page4.m_companyLineEdit->setText( dictionary->getCompany() );
	m_page4.m_dateLineEdit->setText( dictionary->getDate() + " " + dictionary->getTime() );
	m_page4.m_descriptionLineEdit->setText( dictionary->m_deviceInfo? dictionary->m_deviceInfo->getDescription() : "" );

	setCaption( dictionary->getFileName() );

	return success;
}

//////////////////////////////////////////////////////////////////////////////
//	revision control

const char* CDeviceInfoDialog::version()
{
	return (const char*)_id;
}

//////////////////////////////////////////////////////////////////////////////
//	Uwe Vogt,  UV Software,  Steinaecker 28,  88048 Friedrichshafen,  Germany
//	Fon: +49-7541-6041530, Fax. +49-1803-551809359, Cell fon: +49-170-3801903
//	E-Mail: uwe.vogt@uv-software.de, Internet URL: http://www.uv-software.de/
