////// $URL: http://svn.uv-software.com/opensource/linux/CANopen/COPbrowser/trunc/DeviceInfoDialog.h $
//
//	project   :  COPbrowser - CANopen Object Browser
//	
//	purpose   :  DeviceInfoDialog - Tab Dialog
//	
//	copyright :  (C) 2009, UV Software, Friedrichshafen
//
//	compiler  :  GCC - GNU C++ Compiler (Linux Kernel 2.6)
//
//	export    :  class CDeviceInfoDialog
//	
//	includes  :  <includes>
//	
//	author    :  Uwe Vogt, UV Software
//	
//	e-mail    :  uwe.vogt@uv-software.de
//
//////////////////////////////////////////////////////////////////////////////
//	<description>

#ifndef _DeviceInfoDialog_h_
#define _DeviceInfoDialog_h_

//////////////////////////////////////////////////////////////////////////////
//	include-files

#include <q3tabdialog.h>
#include "dic/CANopen.h"

//////////////////////////////////////////////////////////////////////////////
//	forwarder

class QString;
class QLineEdit;

//////////////////////////////////////////////////////////////////////////////
//	class CDeviceInfoDialog

class CDeviceInfoDialog : public Q3TabDialog
{
	Q_OBJECT
	
	//	attributes:
	private:
		struct {
			QLineEdit* m_vendorNameLineEdit;
			QLineEdit* m_vendorNumberLineEdit;
			QLineEdit* m_productNameLineEdit;
			QLineEdit* m_productNumberLineEdit;
			QLineEdit* m_revisionNumberLineEdit;
			QLineEdit* m_orderCodeLineEdit;
			QLineEdit* m_descriptionLineEdit;
		}	m_page1;
		struct {
			QLineEdit* m_baudrate1000LineEdit;
			QLineEdit* m_baudrate800LineEdit;
			QLineEdit* m_baudrate500LineEdit;
			QLineEdit* m_baudrate250LineEdit;
			QLineEdit* m_baudrate125LineEdit;
			QLineEdit* m_baudrate50LineEdit;
			QLineEdit* m_baudrate20LineEdit;
			QLineEdit* m_baudrate10LineEdit;
		}	m_page2;
		struct {
			QLineEdit* m_bootupMasterLineEdit;
			QLineEdit* m_bootupSlaveLineEdit;
			QLineEdit* m_numberOfPDOsLineEdit;
			QLineEdit* m_granularityLineEdit;
			QLineEdit* m_dynamicChannelsLineEdit;
			QLineEdit* m_groupMessagingLineEdit;
			QLineEdit* m_layerSettingsLineEdit;
		}	m_page3;
		struct {
			QLineEdit* m_fileNameLineEdit;
			QLineEdit* m_fileVersionLineEdit;
			QLineEdit* m_EDSVersionLineEdit;
			QLineEdit* m_authorLineEdit;
			QLineEdit* m_companyLineEdit;
			QLineEdit* m_dateLineEdit;
			QLineEdit* m_descriptionLineEdit;
		}	m_page4;
	
	//	constructor/destructor:
	public:
		CDeviceInfoDialog( QWidget* parent = 0, const char* name = 0 );
		~CDeviceInfoDialog();
		
	//	member functions:
	public:
		bool populate( CCANopen* dictionary );
	
	//	revision control:
	public:
		static const char* version();
};

#endif // _DeviceInfoDialog_h_

//////////////////////////////////////////////////////////////////////////////
//	Uwe Vogt,  UV Software,  Steinaecker 28,  88048 Friedrichshafen,  Germany
//	Fon: +49-7541-6041530, Fax. +49-1803-551809359, Cell fon: +49-170-3801903
//	E-Mail: uwe.vogt@uv-software.de, Internet URL: http://www.uv-software.de/
