////// $URL: http://svn.uv-software.com/opensource/linux/CANopen/COPbrowser/trunc/dic/CANopenReader.h $
//
//	project   :  CAN - Controller Area Network
//
//	purpose   :  CANopen Files (Input)
//
//	copyright :  (C) 2009, UV Software, Friedrichshafen
//
//	compiler  :  GCC - GNU C++ Compiler (Linux Kernel 2.6)
//
//	export    :  class CCANopenReader
//
//	includes  :  CANopen.h (CANopenDeviceInfo.h, CANopenObject.h)
//
//	author    :  Uwe Vogt, UV Software
//
//	e-mail    :  uwe.vogt@uv-software.de
//
//////////////////////////////////////////////////////////////////////////////
//	CANopen Files (Input)

#ifndef _CANopenReader_h_
#define _CANopenReader_h_

//////////////////////////////////////////////////////////////////////////////
//	include-files

#include "CANopen.h"

//////////////////////////////////////////////////////////////////////////////
//	class CCANopenReader

class CCANopenReader
{
	//	attributes:
	private:
		CCANopen* m_dictionary;			// CANopen object dictionary
		CCANopen::TFileType m_fileType;	// Type of the CANopen input file

	//	constructor/destructor:
	protected:
		CCANopenReader();
	public:
		CCANopenReader( CCANopen* objectDictionary, CCANopen::TFileType fileType = CCANopen::typeEDS );
		~CCANopenReader();

	//	member functions:
	public:
		int load( const char* fileName );

	private:
		int loadEDS( const char* fileName );
		int loadXML( const char* fileName );
		int loadCOP( const char* fileName );

	//	revision control:
	public:
		static const char* version();
};

#endif // _CANopenReader_h_

//////////////////////////////////////////////////////////////////////////////
//	Uwe Vogt,  UV Software,  Steinaecker 28,  88048 Friedrichshafen,  Germany
//	Fon: +49-7541-6041530, Fax. +49-1803-551809359, Cell fon: +49-170-3801903
//	E-Mail: uwe.vogt@uv-software.de, Internet URL: http://www.uv-software.de/
