////// $URL: http://svn.uv-software.com/opensource/linux/CANopen/COPbrowser/trunc/dic/IniReader.h $
//
//	project   :  IniReader - Windows INI-Files
//	
//	purpose   :  IniReader - a simple interface to read INI-Files
//	
//	copyright :  (C) 2009, UV Software, Friedrichshafen
//
//	compiler  :  GCC - GNU C++ Compiler (Linux Kernel 2.6)
//
//	export    :  class CIniReader
//	
//	includes  :  <includes>
//	
//	author    :  Uwe Vogt, UV Software
//	
//	e-mail    :  uwe.vogt@uv-software.de
//
//////////////////////////////////////////////////////////////////////////////
//	IniReader: A Forward-Reader for INI-Files (e.g. CANopen EDS-Files).

#ifndef _IniReader_h_
#define _IniReader_h_

//////////////////////////////////////////////////////////////////////////////
//	include-files

#include <qfile.h>
#include <qstring.h>

//////////////////////////////////////////////////////////////////////////////
//	class CIniReader

class CIniReader
{
	//	enumerations:
	public:
		enum {Section = 1, Item, Error = 0, None = -1};
	
	//	attributes:
	private:
		QFile	m_file;
		
		QString	m_section;
		QString	m_key;
		QString	m_value;
	
	//	constructor/destructor:
	public:
		CIniReader( const char* fileName );
		~CIniReader();
	protected:
		CIniReader();
	
	//	member functions:
	public:
		QString	getSection()	{ return m_section; };
		QString	getKeyName()	{ return m_key; };
		QString	getKeyValue()	{ return m_value; };

		int		moveToNextItem();

		static	int	getLineOfError();
	
	//	revision control:
	public:
		static const char* version();
};

#endif // _IniReader_h_

//////////////////////////////////////////////////////////////////////////////
//	Uwe Vogt,  UV Software,  Steinaecker 28,  88048 Friedrichshafen,  Germany
//	Fon: +49-7541-6041530, Fax. +49-1803-551809359, Cell fon: +49-170-3801903
//	E-Mail: uwe.vogt@uv-software.de, Internet URL: http://www.uv-software.de/
